// Question 1: GCD

// Consider the following Dafny specification and code which calculate the
// greatest common divisor of two numbers. The function gcd defines the grates
// common divisor, while the method GcdCal calculates the greatest common
// divisor. Annotate the method body with appropriate pre-, post- conditions
// and invariants in order to verify the code.

function gcd(m: nat, n: nat): nat
  requires m>=1;
  requires n>=1;
  decreases m+n;
{ 
  if (n==m) then n 
  else if (m>n) then gcd (m-n,n) 
  else gcd(m,n-m) 
}

method GcdCal(m: nat, n: nat) returns (res: nat)
  requires ???;
  ensures res == gcd(m, n);
{ 
  var m1: nat, n1: nat := m, n;

  while (m1!=n1) 
    invariant ???;
    decreases ???;
  {  
    if (m1>n1) { 
      m1 := m1-n1; 
    } 
    else { 
      n1 := n1-m1;  
    }
 }
 return m1;
}

